import javax.swing.*;
import java.util.ArrayList;
import java.util.Vector;
import java.net.URL;
import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import javax.swing.tree.*;
import javax.swing.event.*;
import javax.swing.filechooser.FileFilter;
import java.io.*;
import grph.*;

class gridNet extends Canvas{

public static final int width=400; //fix width
public static final int maxhigh=400;   //and max height
public String currentGenome="";
public GRNconverter currentGRN;
public static final boolean environmentAsNode=true;
public grph.grid track;
public graph[] graphs;
public gene[] lesioned;
public static int highlightMotif=-1;
public static int subnetSize=0;

public gridNet(){
this(null);
}

public gridNet(grph.grid track){
this.track=track;
this.addMouseListener(new MouseListener(){
  public void mousePressed(MouseEvent e){
    boolean lesion=false;
    if(e.getButton()!=MouseEvent.BUTTON1)
      lesion=true;
    onClick(e.getX(),e.getY(),lesion);  //call this method on clicks with mouseposition
  }
  public void mouseEntered(MouseEvent e){}
  public void mouseExited(MouseEvent e){}
  public void mouseClicked(MouseEvent e){}
  public void mouseReleased(MouseEvent e){}
}
);
}

public Dimension getMinimumSize(){
return new Dimension(width,maxhigh);
}

public Dimension getMaximumSize(){
return new Dimension(width,maxhigh);
}

public Dimension getPreferredSize(){
return getMaximumSize();
}
public boolean loadNet(File from){
String genome=GRNconverter.readGenomeFromFile(from);
return loadNet(genome);
}

public boolean loadNet(String genome){
currentGenome=genome;
currentGRN=GRNconverter.GRNfromString(genome);
if(currentGRN!=null){
  currentGRN.getNewInput();
  int max=currentGRN.genes.length;
  if(environmentAsNode)
    max+=1;
  graphs=new graph[max+1];
  for(int i=0;i<max+1;i++)
    graphs[i]=new graph(showNet.maxTrack);
  resetGraphs();
  updateGraphs();
  repaint();
  }
lesioned=new gene[currentGRN.genes.length];
return (currentGRN!=null);
}

public void step(boolean indu){
  for(int i=0;i<currentGRN.genes.length;i++){
    if((lesioned[i]!=null)&&(currentGRN.genes[i]!=null)){
      currentGRN.genes[i]=null;
      KnabeGene t=(KnabeGene)lesioned[i];
      for(int x=0;x<t.proteinSiteActivations.length;x++)
       for(int j=0;j<t.proteinSiteActivations[x].length;j++)
        t.proteinSiteActivations[x][j]=0;
      }
    }
  currentGRN.step(indu);
  repaint();
  if(track!=null){
    int max=currentGRN.genes.length;
    for(int i=0;i<max;i++){
     if(currentGRN.genes[i]!=null)
      graphs[i+1].add(((KnabeGene)currentGRN.genes[i]).lastRet/150.0);
     else
      if(lesioned[i]!=null)
       graphs[i+1].add(0.0);
     }
    if(environmentAsNode)
      graphs[max+1].add(currentGRN.lastIn);
    graphs[0].add(currentGRN.outval);//graph 0 is always network output
    track.repaint();
    }
}

/*public void update(Graphics g){
  paint(g);
}*/

public int transformX(int what){
double scaleW=(getWidth()/2.0)-geneWidth;
what=(what+(int)scaleW)+(geneWidth/2);
return what;
}

public int transformY(int what){
double scaleH=(getHeight()/2.0)-geneHeight;
what=(what+(int)scaleH)+(geneHeight/2);
return what;
}

public void onClick(int x,int y, boolean lesion){
if(currentGRN==null)
  return;
int max=currentGRN.genes.length;
if(environmentAsNode)
  max+=1;
for(int i=0;i<max;i++){
  Dimension pos=getGenePos(i);
  if((x>transformX(pos.width-(geneWidth/2)))&&(x<transformX(pos.width+(geneWidth/2)))&&
  (y>transformY(pos.height-(geneHeight/2)))&&(y<transformY(pos.height+(geneHeight/2))))
    nodeClicked(i,lesion);
  }
}

public int[] showGraphs;

//the graph given will additionally be shown
public void addGraph(int geneNumber){
if(showGraphs!=null)
 for(int i=0;i<showGraphs.length;i++)
  if(showGraphs[i]==geneNumber){//is already there, so deselect!!!
    if(showGraphs.length==1){
      resetGraphs();
      return;
      }
    int[] t=new int[showGraphs.length-1];
    if(i!=0)
      System.arraycopy(showGraphs,0,t,0,i);
    if(i!=showGraphs.length-1)
      System.arraycopy(showGraphs,i+1,t,i,showGraphs.length-i-1);
    showGraphs=t;
    updateGraphs();
    return;
    }
int nu=1;
if(showGraphs!=null)
  nu=showGraphs.length+1;
int[] t=new int[nu];
t[t.length-1]=geneNumber;
if(showGraphs!=null)
  System.arraycopy(showGraphs,0,t,0,showGraphs.length);
showGraphs=t;
updateGraphs();
}

//no graphs will be shown
public void resetGraphs(){
showGraphs=null;
updateGraphs();
}

//synchronizes our data with the actual graph drawer
public void updateGraphs(){
  if(showGraphs==null){
    track.graphs=new graph[]{this.graphs[0]};
    return;
    }
  graph[] t=new graph[showGraphs.length+1];
  for(int i=0;i<showGraphs.length;i++)
    t[i+1]=this.graphs[showGraphs[i]+1];
  t[0]=this.graphs[0];
  track.graphs=t;
}

public void nodeClicked(int which, boolean lesion){
 if(!lesion)
  addGraph(which);
 else{
  if(which>=lesioned.length)
    return;
  if(lesioned[which]==null)
   lesioned[which]=currentGRN.genes[which];
  else
   if(currentGRN.genes[which]==null){
    currentGRN.genes[which]=lesioned[which];
    lesioned[which]=null;
    }
 }
}

public Dimension getGenePos(int geneNumber){
Dimension ret=new Dimension();
double numNodes=(currentGRN.genes.length*1.0);
if(environmentAsNode)
  numNodes+=1;
double rad=(2.0*Math.PI)/numNodes*(geneNumber*1.0);
double scaleW=(getWidth()/2.0)-geneWidth;
double scaleH=(getHeight()/2.0)-geneHeight;
ret.width= (int)((Math.cos(rad)*scaleW));
ret.height=(int)((Math.sin(rad)*scaleH));
return ret;
}

public final int geneWidth= 20;
public final int geneHeight=20;

public void paintEnvNode(int number, Graphics g){
double act=currentGRN.lastIn;
double norm=1.0;//(output is between 0 and floor+range, which is currently 0+150=150)
int gray=(int)(act/norm*255.0);
g.setColor(new Color(gray,gray,gray));
Dimension pos=getGenePos(number);
g.fillRoundRect(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight,6,6);
int gNum=-1;
if(showGraphs!=null)
 for(int i=0;i<showGraphs.length;i++)
  if(showGraphs[i]==number)
   gNum=i;
if(gNum>=0){
 g.setColor(grph.grid.colors[gNum+1]);
 g.drawRoundRect(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight,6,6);  
 }
}

public void paintGene(int geneNumber, Graphics g){
double act;
int outputType;
if(lesioned[geneNumber]!=null){
  outputType=((KnabeGene)lesioned[geneNumber]).geneOutputActivity;
  g.setColor(Color.BLUE);
  }
else{
  act=((KnabeGene)currentGRN.genes[geneNumber]).lastRet;
  outputType=((KnabeGene)currentGRN.genes[geneNumber]).geneOutputActivity;
  double norm=150;//(output is between 0 and floor+range, which is currently 0+150=150)
  int gray=(int)(act/norm*255.0);
  g.setColor(new Color(gray,gray,gray));
  }
Dimension pos=getGenePos(geneNumber);

int gNum=-1;
if(showGraphs!=null)
 for(int i=0;i<showGraphs.length;i++)
  if(showGraphs[i]==geneNumber)
   gNum=i;
if(outputType==1){ //default 'off' gene
  g.fillOval(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight);
  if(gNum>=0){
    g.setColor(grph.grid.colors[gNum+1]);
    g.drawOval(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight);
    }
  }
else{ //default 'on' gene
  g.fillRect(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight);
  if(gNum>=0){
    g.setColor(grph.grid.colors[gNum+1]);
    g.drawRect(transformX(pos.width-(geneWidth/2)),transformY(pos.height-(geneHeight/2)),geneWidth,geneHeight);
    }
  }
}

public void paintLink(int fromGene, int toGene, boolean inhibitory, Graphics g){
Dimension from=getGenePos(fromGene);
Dimension from2=new Dimension();
if(inhibitory)
  g.setColor(Color.BLUE);
else
  g.setColor(Color.RED);
if(fromGene==toGene){
  int w=2*geneWidth;
  int h=2*geneHeight;
  g.drawArc(transformX(from.width)-w,transformY(from.height)-h/2,w,h,0,300);
  return;
}
Dimension to=getGenePos(toGene);
Dimension to2=new Dimension();

//from.width +=toGene;
//from.height+=toGene;
to.width +=fromGene;
to.height+=fromGene;

to2.width =to.width;
to2.height=to.height;
to2.width-= from.width;
to2.height-=from.height;
//System.out.println(fromGene+" -> "+toGene+" : "+to.width+" "+to.height);
double div=Math.sqrt(to2.width*to2.width+to2.height*to2.height);
double scale=1.0-Math.sqrt(geneWidth*geneWidth+geneHeight*geneHeight)/div;
to2.width= (int)(to2.width*scale);
to2.height=(int)(to2.height*scale);
from2.width=transformX(from.width);
from2.height=transformY(from.height);
g.drawLine(from2.width,from2.height,from2.width+to2.width,from2.height+to2.height);

//now finally draw a bar or an arrow at the end of the link:
double size=geneWidth/2.0;
if(inhibitory){
  div=Math.sqrt(to2.height*to2.height+to2.width*to2.width);
  to.width= (int)(to2.height/div*size);
  to.height=(int)(to2.width/div *size);
  g.drawLine(from2.width+to2.width-to.width,from2.height+to2.height+to.height,from2.width+to2.width+to.width,from2.height+to2.height-to.height);
  }
else{
  g.drawOval((int)(from2.width+to2.width-size/2),(int)(from2.height+to2.height-size/2),(int)size,(int)size);
  }
}

public void paint(Graphics g){
g.setColor(Color.BLACK);
if(currentGRN==null){
  g.drawString("Please load genome file!",10,getHeight()/2);
  return;}

int envNode=currentGRN.genes.length;
KnabeGene ttt=null;
KnabeGene ttt2=null;
int[] curr;
for(int i=0;i<currentGRN.genes.length;i++){//go through all proteins and check their output
 ttt=(KnabeGene) currentGRN.genes[i];
 if((ttt==null)&&(lesioned[i]==null)) continue;
 if(lesioned[i]!=null)
   ttt=(KnabeGene) lesioned[i];

if(environmentAsNode)
 if(ttt.geneOutputProtein==6)//outputs to environment
  paintLink(i,envNode,false,g);


for(int h=0;h<currentGRN.genes.length;h++){//go through all genes to see who uses ttt's output
 ttt2=(KnabeGene) currentGRN.genes[h];
 if((ttt2==null)&&(lesioned[h]==null)) continue;
 if(lesioned[h]!=null)
   ttt2=(KnabeGene) lesioned[h];
 for(int j=0;j<ttt2.geneCisReceptorSites.length;j++){
  curr=ttt2.getCisSite(j);
  //if(curr[0]==0) System.out.print("inhibitory");
  //else System.out.print("activatory");
  for(int l=1;l<curr.length;l++){//leaves 0 out because that has inhib./act. meaning
    if(curr[l]==ttt.geneOutputProtein){
     if(curr[0]==0)
      paintLink(i,h,true,g); //inhibitory
     else
      paintLink(i,h,false,g);
     }

    if(curr[l]==1)//will be called lots of times but doesn't matter as we don't count doubles
      paintLink(envNode,h,false,g);//_h_ is influenced by the environment

    }
 }
}
}//end go through all proteins and check their output


g.setColor(Color.BLACK);
for(int i=0;i<currentGRN.genes.length;i++)
 if((currentGRN.genes[i]!=null)||(lesioned[i]!=null))
  paintGene(i,g);
if(environmentAsNode){
 paintEnvNode(envNode,g);
 }
g.setColor(grph.grid.colors[0]);
g.drawString("Summaric network output in green, left-click nodes to plot their output.",2,getHeight()-17);
if(highlightMotif>=0)
  g.drawString("Right-click nodes to turn them off. Highlighting motif "+highlightMotif+".",2,getHeight()-5);
else
  g.drawString("Right-click nodes to turn them off.",2,getHeight()-5);
}

}//end gridNet class

public class showNet extends Applet{

public static int maxTrack=100;

private boolean inBrowser=true;
public  gridNet net;
public controlGrid conti;
public grid track;

public String getAppletInfo()
{
return "ShowNetwork - Author: Johannes Knabe, jknabe@panmental.de - 26.09.2006 - Source available at http://panmental.de";
}

public void init(boolean inBrowser){
this.inBrowser=inBrowser;
init();
}

public void init() {
    track=new grid(null,0,maxTrack,-0.1,1.1);

    GridBagLayout gridbag = new GridBagLayout();

    GridBagConstraints c2 = new GridBagConstraints();
    c2.anchor=GridBagConstraints.SOUTH;
    c2.ipadx=10;
    c2.ipady=10;
    c2.gridwidth =2;
    c2.gridx=0;
    c2.gridy=1;
    gridbag.setConstraints(track, c2);

    setLayout(gridbag);
    net=new gridNet(track);

    GridBagConstraints c1 = new GridBagConstraints();
    c1.anchor=GridBagConstraints.NORTHWEST;
    c1.ipadx=10;
    c1.ipady=0;
    c1.gridx=0;
    c1.gridy=0;
    gridbag.setConstraints(net, c1);
    add(net);
    conti =new controlGrid(net);
    GridBagConstraints c3 = new GridBagConstraints();
    c3.anchor=GridBagConstraints.EAST;
    c3.gridx=1;
    c3.gridy=0;
    gridbag.setConstraints(conti, c3);
    add(conti);
    if(inBrowser)
      conti.loadFile.setEnabled(false);
    if(!inBrowser){
      conti.control.setEnabled(false);
      conti.step.setEnabled(false);
      }
    add(track);
}

public void start(){
    if(inBrowser){
     String geno=getParameter("genome");
     if(geno!=null){
       int inputFunc=0;
       String func=getParameter("inputFunc");
       if(func!=null)
         inputFunc=Integer.parseInt(func);

       String sS=getParameter("subnetSize");
       if(sS!=null)
         gridNet.subnetSize=Integer.parseInt(sS);
       String hM=getParameter("highlightMotif");
       if((hM!=null)&&(subnetSize>0))
         gridNet.highlightMotif=Integer.parseInt(hM);
       KnabeGRN.setInputFunction(inputFunc);
       net.loadNet(geno);
       int max=net.currentGRN.genes.length;
       if(net.environmentAsNode)
         net.addGraph(max);
       conti.controlClick();
     }
   }
}

public void stop(){
this.conti=null;
this.net=null;
this.track=null;
}

public static void main(String[] argv){
new AppletFrame("Show network dynamics, Graphical Interface",new showNet(),640,480);
}
}//end class showNet

class controlGrid extends Container{

public int time=0;
public Label timeLabel;
public Button control;
public Button step;
public Timer actionTimer;
public Scrollbar bar;
public static final int width=120; //fix width
public static final int maxhigh=300;   //and max height
public int mode=0;
public final int initDelay=250;
public gridNet net;
public Button loadFile;
public Button resetGraphs;
public Checkbox inducer;
public boolean inducible=true;

public Dimension getMinimumSize(){
return new Dimension(width,maxhigh);
}

public Dimension getMaximumSize(){
return new Dimension(width,maxhigh);
}

public Dimension getPreferredSize(){
return getMaximumSize();
}

public String getStateText(){
 if(mode==2)
  mode=0;
 switch(mode){
  case 0: step.setEnabled(true); return "play";
  case 1: step.setEnabled(false); return "pause";
 }
 return "Error";
}

public void controlClick(){
 mode++;
 control.setLabel(getStateText());
 if(mode==1)
  actionTimer.start();
 if(mode==0)
  actionTimer.stop();
}

public void timerEvent(){
  doStep();
}

public void doStep(){
 time++;
 timeLabel.setText(""+time);
 resetGraphs.setEnabled(net.showGraphs!=null);
 net.step(inducer.getState());
}

public void stepClick(){
 doStep();
}

public void resetGraphsClick(){
 net.resetGraphs();
 resetGraphs.setEnabled(net.showGraphs!=null);
}

public void loadClick(){
    JFileChooser chooser = new JFileChooser();
    chooser.setFileFilter(chooser.getAcceptAllFileFilter());
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
       System.out.print("Loading net from this file: " +
            chooser.getSelectedFile().getName());
       if(net.loadNet(chooser.getSelectedFile())){
         control.setEnabled(true);
         step.setEnabled(true);
         System.out.println(" successful.");
         }
       else
         System.out.println(" failed.");
    }
}

public void delayChanged(){
 actionTimer.setDelay(initDelay-bar.getValue());
}

public controlGrid(gridNet net){
this.net=net;
actionTimer=new Timer(initDelay,new ActionListener(){
   public void actionPerformed(ActionEvent e){
    timerEvent();
    }
   }
 );
setLayout(new GridLayout(0,1));
add(new Label("time:"));
timeLabel=new Label("0");
add(timeLabel);
add(new Label("speed:"));
bar= new Scrollbar(Scrollbar.HORIZONTAL, initDelay/2-10,20,0, initDelay);//SpeedScrollbar
add(bar);                          //add it 
add(new Label("controls:"));
bar.addAdjustmentListener(new AdjustmentListener(){
  public void adjustmentValueChanged(AdjustmentEvent e){
    delayChanged(); //function called when bar is changed
    }
  }
  );
step=new Button("step");
control=new Button(getStateText());
add(control);
control.addActionListener(new ActionListener(){
  public void actionPerformed(ActionEvent e){
    controlClick();  //call this function when button clicked
    }
  }
  );
resetGraphs=new Button("no graphs");
add(resetGraphs);
resetGraphs.setEnabled(false);
resetGraphs.addActionListener(new ActionListener(){
  public void actionPerformed(ActionEvent e){
    resetGraphsClick();  //call this function when button clicked
    }
  }
  );
add(step);
step.addActionListener(new ActionListener(){
  public void actionPerformed(ActionEvent e){
    stepClick();  //call this function when button clicked
    }
  }
  );
loadFile=new Button("load net");
add(loadFile);
loadFile.addActionListener(new ActionListener(){
  public void actionPerformed(ActionEvent e){
    loadClick();  //call this function when button clicked
    }
  }
  );
inducer=new Checkbox("inducer");
if(inducible){
  add(inducer);
  }
}

}//end class controlGrid

class AppletFrame extends JFrame {

private showNet display;

AppletFrame(String title, showNet applet, int width, int height){
  super(title);
  display=applet;
  applet.init(false);
  this.getContentPane().add(applet);
  this.setSize(width,height);
  this.pack();
  applet.setVisible(true);
  this.setVisible(true);
  addWindowListener(
      new WindowAdapter() {  // close the window when the user clicks its close box
          public void windowClosing(WindowEvent evt) {
          close();
          }
      });
}

public void close(){
   System.exit(0);
   }

}
